/**
 * 修改增加开票信息
 * */
$(function() {
	autosize($('textarea'));
	laydate.render({
		elem: '#F_BillingTime',
		calendar: true,
		theme: '#1ab394'
	});
// 	//获取发票类型 税率
	$.when(helper.getDropList.getlistDropByDic($('#F_BillType'), 'FPLX'),
			helper.getDropList.getlistDropByDic($('#F_TaxRate'), 'KPSL'))
		.done(function() {
			var edit_id = helper.request.queryString("edit_id");
			if (edit_id) {
				getCustomer(edit_id);
			}
			//绑定验证(所有 input.form-control)
			$('#tab_user_contents').find("input[class='form-control']").on('blur keyup', valideInput);
		});

});

//获取详情
function getCustomer(ids) {
	$.getJSON(huayi.config.callcenter_url + "WoBill/GetBill", {
		billid: ids, //id
		token: $.cookie("token")
	}, function(data) {
		if (data.state.toLowerCase() == "success") {
			data = data.data.dModel;
			if (data) {
				$('#F_BillType').selectpicker('val', data.F_BillType);//	string 发票类型	
				$('#F_TaxIDNum').val(data.F_TaxIDNum);//	string 纳税人识别号
				$('#F_CusName').val(data.F_CusName);//	string 客户名称	
				$('#F_Phone').val(data.F_Phone);//	string 电话
				$('#F_Address').val(data.F_Address);//	string 地址	
				$('#F_Bank').val(data.F_Bank);//	string 开户行
				$('#F_BankAccount').val(data.F_BankAccount);//	string 开户行账号	
				$('#F_ProName').val(data.F_ProName);//	string 项目名称	
				$('#F_Models').val(data.F_Models);//	string 型号
				$('#F_Unit').val(data.F_Unit);//	string 单位	
				$('#F_Amount').val(data.F_Amount);//	string 数量	
				$('#F_UnitPrice').val(data.F_UnitPrice);//	string 单价
				$('#F_SumPrice').val(data.F_SumPrice);//	string 金额	
				$('#F_TaxRate').selectpicker('val', data.F_TaxRate);//	string 税率	
				$('#F_TaxAmount').val(data.F_TaxAmount);//	string 税额
				$('#F_State').find('input[type="radio"][value="'+ data.F_State  +'"]').prop('checked', true);//	F_State 是否开票 0否1是
				$('#F_BillingMethod').find('input[type="radio"][value="'+ data.F_BillingMethod  +'"]').prop('checked', true);//	string 开票方式：快递/自取	
				$('#F_BillingTime').val(data.F_BillingTime);//string 开票时间
				$('#F_Remark').val(data.F_Remark);//string 备注
				// $('#F_CusCode').val(data.F_CusCode);//	string 登录的公司code
				$('#F_TaxIDNum').trigger('blur');
			}
		}
	});
}

//保存
function saveCustomer() {
	if (!$.trim($('#F_BillType').val()) ||
			!$.trim($('#F_TaxIDNum').val()) ||
			!$.trim($('#F_CusName').val()) ||
			!$.trim($('#F_Phone').val()) ||
			!$.trim($('#F_Address').val()) ||
			!$.trim($('#F_Bank').val()) ||
			!$.trim($('#F_BankAccount').val()) ||
			!$.trim($('#F_ProName').val()) ||
			!$.trim($('#F_Unit').val()) ||
			!$.trim($('#F_Amount').val()) ||
			!$.trim($('#F_UnitPrice').val()) ||
			!$.trim($('#F_SumPrice').val()) ||
			!$.trim($('#F_TaxRate').val()) ||
			!$.trim($('#F_TaxAmount').val()) ||
			!$.trim($('#F_BillingTime').val()) ||
			!$.trim($('#F_Remark').val())) {
		layer.msg('带红色星号的是必填项，请填写或选择后再保存！');
		return;
	}
	var wURL, loadIndex;
	var edit_id = helper.request.queryString("edit_id");
	if (edit_id) {
		wURL = "WoBill/UpdateBill";
	} else {
		wURL = "WoBill/AddBill";
	}
	$.ajax({
		type: 'post',
		url: huayi.config.callcenter_url + wURL,
		dataType: 'json',
		async: true,
		beforeSend: function() { //触发ajax请求开始时执行
			$('#save_btns').attr("disabled", true);
			$('#save_btns').text('保存中...');
			loadIndex = layer.load();
		},
		data: {
			F_ID: edit_id,//主ID
			F_BillType: $('#F_BillType').val(),//	string 发票类型	
			F_CusName: $('#F_CusName').val(),//	string 客户名称	
			F_TaxIDNum: $('#F_TaxIDNum').val(),//	string 纳税人识别号
			F_Address: $('#F_Address').val(),//	string 地址	
			F_Phone: $('#F_Phone').val(),//	string 电话
			F_Bank: $('#F_Bank').val(),//	string 开户行
			F_BankAccount: $('#F_BankAccount').val(),//	string 开户行账号	
			F_ProName: $('#F_ProName').val(),//	string 项目名称	
			F_Models: $('#F_Models').val(),//	string 型号
			F_Unit: $('#F_Unit').val(),//	string 单位	
			F_Amount: $('#F_Amount').val(),//	string 数量	
			F_UnitPrice: $('#F_UnitPrice').val(),//	string 单价
			F_SumPrice: $('#F_SumPrice').val(),//	string 金额	
			F_TaxRate: $('#F_TaxRate').val(),//	string 税率	
			F_TaxAmount: $('#F_TaxAmount').val(),//	string 税额
			F_State: $('#F_State').find('input[type="radio"]:checked').val(),// 是否开票 0否1是
			F_BillingMethod: $('#F_BillingMethod').find('input[type="radio"]:checked').val(),//	string 开票方式：快递/自取	
			F_BillingTime: $('#F_BillingTime').val(),//string 开票时间
			F_Remark: helper.filter.delHtmlTag($('#F_Remark').val()),//string 备注
			// F_CusCode: $('#F_CusCode').val(),//	string 登录的公司code
			token: $.cookie("token")
		},
		success: function(data) {
			layer.close(loadIndex);
			if (data.state === "success") {
				var index = parent.layer.getFrameIndex(window.name);
				parent.layer.close(index);
				parent.$('#workorderlist').bootstrapTable('refresh');
				parent.layer.msg("保存成功");
			} else {
				$('#save_btns').attr("disabled", false);
				$('#save_btns').text('保存');
			}
		},
		error: function(textStatus) {
			layer.close(loadIndex);
			layer.confirm('网络繁忙，请稍后再试...', {
				icon: 7,
				closeBtn: 0,
				btn: ['确定'] //按钮
			});
			$('#save_btns').attr("disabled", false);
			$('#save_btns').text('保存');
		},
		complete: function(XMLHttpRequest, textStatus) {
			layer.close(loadIndex);
			if (textStatus == 'timeout') {
				var xmlhttp = window.XMLHttpRequest ? new window.XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHttp");
				xmlhttp.abort();
				layer.confirm('网络超时，请稍后再试...', {
					icon: 7,
					closeBtn: 0,
					btn: ['确定'] //按钮
				});
			}
			$('#save_btns').attr("disabled", false);
			$('#save_btns').text('保存');
		},
	});
}


//验证(所有 input.form-control)的方法
function valideInput() {
	var _that = $(this);
	//console.log($(this).attr('id'));
	switch ($(this).attr('id')) {
		case 'F_TaxIDNum': //纳税人识别号
			valideMethods(_that, regexs.enOrnum, '格式不正确(只能输入英文、数字)！', false);
			break;
		case 'F_CusName': //客户名称
			valideMethods(_that, regexs.userNameReg, '格式不正确(只能输入2-20位汉字可以包含·•)！', false);
			break;
		case 'F_Phone': //验证电话
			valideMethods(_that, regexs.phone, '您输入的电话号码格式不正确！', false);
			break;
		case 'F_Bank': //开户行
			valideMethods(_that, regexs.chOrenOrnum, '格式不正确（只能输入中文、英文、数字）！', false);
			break;
		case 'F_Address': //地址
			valideMethods(_that, regexs.chOrenOrnum, '格式不正确（只能输入中文、英文、数字）！', false);
			break;
		case 'F_BankAccount': //开户行账号
			valideMethods(_that, regexs.num, '格式不正确（只能输入数字）！', false);
			break;
		case 'F_ProName': //项目名称
			valideMethods(_that, regexs.chOrenOrnum, '格式不正确（只能输入中文、英文、数字）！', false);
			break;
		case 'F_Models': //型号
			valideMethods(_that, regexs.chOrenOrnum, '格式不正确（只能输入中文、英文、数字）！', true);
			break;
		case 'F_Unit': //单位
			valideMethods(_that, regexs.chOrenOrnum, '格式不正确（只能输入中文、英文、数字）！', false);
			break;
		case 'F_Amount': //数量
			valideMethods(_that, regexs.chOrenOrnum, '格式不正确（只能输入中文、英文、数字）！', false);
			break;
		case 'F_UnitPrice': //单价
			valideMethods(_that, regexs.amountMoneys, '格式不正确（只能输入中文、英文、正数、必须包含正数）！', false);
			break;
		case 'F_SumPrice': //金额
			valideMethods(_that, regexs.amountMoneys, '格式不正确（只能输入中文、英文、正数、必须包含正数）！', false);
			break;
		case 'F_TaxAmount': //税额
			valideMethods(_that, regexs.amountMoneys, '格式不正确（只能输入中文、英文、正数、必须包含正数）！', false);
			break;
	}
	if ($('#tab_user_contents').find('.has-error').length > 0) {
		$('.project_save').attr('disabled', true);
		$('#save_btns').off('click', saveCustomer);
	} else {
		$('.project_save').attr('disabled', false);
		$('#save_btns').off('click', saveCustomer);
		$('#save_btns').on('click', saveCustomer);
	}
}
/**
 * 验证方法
 * _this :传递的this
 * regRlues: 验证的规则
 * msg: 提示信息
 * isRes:boolean 是否允许验证的内容为空，true:允许为空，false:不允许为空
 * */
function valideMethods(_this, regRlues, msg, isRes) {
	var txtTpips = _this.parent().parent().find('.text-tips');
	if (txtTpips) {
		txtTpips.parent().remove();
	}
	if (!isRes) {
		//不为空
		if (!regRlues.test($.trim(_this.val()))) {
			_this.parent().parent().removeClass('has-success has-feedback').addClass('has-error has-feedback');
			_this.parent().find('.glyphicon').remove();
			$('<span class="glyphicon glyphicon-remove form-control-feedback" aria-hidden="true"></span>').appendTo(_this.parent());
			$('<div class="col-md-10 col-md-offset-2"><span class="text-tips">' + msg + '</span></div>').appendTo(_this.parent()
				.parent());
			$('.project_save').attr('disabled', true);
		} else {
			_this.parent().parent().removeClass('has-error has-feedback').addClass('has-success has-feedback');
			_this.parent().find('.glyphicon').remove();
			$('<span class="glyphicon glyphicon-ok form-control-feedback" aria-hidden="true"></span>').appendTo(_this.parent());
		}
	} else {
		//为空不验证；但是有内容就验证；
		if ($.trim(_this.val())) {
			if (!regRlues.test($.trim(_this.val()))) {
				_this.parent().parent().removeClass('has-success has-feedback').addClass('has-error has-feedback');
				_this.parent().find('.glyphicon').remove();
				$('<span class="glyphicon glyphicon-remove form-control-feedback" aria-hidden="true"></span>').appendTo(_this.parent());
				$('<div class="col-md-10 col-md-offset-2"><span class="text-tips">' + msg + '</span></div>').appendTo(_this.parent()
					.parent());
				$('.project_save').attr('disabled', true);
			} else {
				_this.parent().parent().removeClass('has-error has-feedback').addClass('has-success has-feedback');
				_this.parent().find('.glyphicon').remove();
				$('<span class="glyphicon glyphicon-ok form-control-feedback" aria-hidden="true"></span>').appendTo(_this.parent());
			}
		} else {
			_this.parent().find('.glyphicon').remove();
			_this.parent().parent().removeClass('has-error has-success has-feedback');
		}
	}
}
